# Отладка приложения

При написании кода неизбежно возникают ошибки и если синтаксические ошибки нам помогает обнаружить среда разработки (IDE), то часть ошибок могут проявиться только при работе приложения (**Run Time Error** - ошибки времени выполнения). Это могут быть как логические ошибки программиста, так и неверные входные данные.

Поиск ошибок выполняется двумя способами: *отладка* и *тестирование*. Тестирование отдельная большая тема и мы будем изучать его в следующем году.

Все IDE позволяют производить отладку приложения, т.е. пошаговое выполнение кода с просмотром значений переменных (для компилируемых приложений есть специальный режим сборки- **debug**, когда в код программы включается отладочная информация, позволяющая связать двоичный код с исходным). 

Для запуска приложения нужно кликнуть по кнопке **Run** или **Debug**:

![](../img/rider06.png)

Перед запуском в режиме отладки установите **точку остановки** в том месте кода, которое вы хотите проверить (просто кликнув кнопкой по левому полю):

![](../img/rider05.png)

Когда выполнение приложения дойдет до этой точки, выполнение приостановится и мы сможем исследовать состояние и пошагово выполнить код:

* желтая стрелка слева показывает в каком месте кода мы находимся
* в нижней панели есть кнопки, позволяющие выполнять код по шагам. эти кнопки имеют и быстрые клавиши

    * *шаг с заходом* (F7) - используется, если мы хотим "зайти" в функцию, которая находится в текущей строке
    * *шаг с обходом* (F8) - выражение в текущей строке выполняется за один шаг, без захода

* значение переменной можно посмотреть 
    * либо просто наведя курсор на неё:

        ![](../img/rider07.png)

    * либо, если нам нужно отслеживать её значение на каждом шаге, внизу экрана 

        Можно на вкладке "Thread & Variables" добавить сложное выражение (цепочку свойств объекта или даже вызов функции)
